{$G+} {i286 Instructions}
{$M, 1024,0,0}

USES GUtils;
TYPE
  TRgb   = RECORD
    Red  : Byte;
    Green: Byte;
    Blue : Byte;
  END;
  TPal   = ARRAY[0..255] OF TRgb;

VAR
  Pal    : TPal;


PROCEDURE HLine(X1,X2,Y:Integer; Color:Byte);
VAR LineOffset:Integer;
BEGIN
  LineOffset := (Y*320)+X1;
  FillChar(Ptr($A000,LineOffset)^,X2-X1,Color);
END;

PROCEDURE SetIntensity(Intensity:Byte);
VAR I:Byte;
BEGIN
  Port[$3C8] := $00;
  FOR I := 0 TO 255 DO
  BEGIN
    Port[$3C9] := Pal[I].Red   * Intensity DIV 63;
    Port[$3C9] := Pal[I].Green * Intensity DIV 63;
    Port[$3C9] := Pal[I].Blue  * Intensity DIV 63;
  END;
END;


PROCEDURE FadeDownMax;
VAR I:Byte;
BEGIN
  FOR I := 63 DOWNTO 0 DO
  BEGIN
     ASM
       MOV  DX, $3DA
   @VRetrace:
       IN   AL, DX
       TEST AL, 8
       JZ   @VRetrace    {Wait for end of vertical retrace}
    END;
    SetIntensity(I);
    Delay(10);
  END;
END;

PROCEDURE BIOSWrite(Str:STRING; Color:Byte); ASSEMBLER;
ASM
     LES  DI, Str
     MOV  CL, ES:[DI]
     INC  DI
     XOR  CH, CH
     MOV  BL, Color
     JCXZ @ExitWrite
 @LoopWrite:
     MOV  AH, 0EH
     MOV  AL, ES:[DI]
     INT  10H
     INC  DI
     LOOP @LoopWrite
 @ExitWrite:
END;



(*PROCEDURE SetPal(APal:TPal);
VAR I:Byte;
BEGIN
  ASM
     MOV  DX, $3DA
  @VRetrace:
     IN   AL, DX
     TEST AL, 8
     JZ   @VRetrace    {Wait for end of vertical retrace}
  END;
  Port[$3C8] := $00;
  FOR I := 0 TO 255 DO
  BEGIN
    Port[$3C9] := Pal[I].Red;
    Port[$3C9] := Pal[I].Green;
    Port[$3C9] := Pal[I].Blue;
  END;
END;*)

PROCEDURE SetPal(VAR APal:TPal); ASSEMBLER;
CONST
  CrtcPort = $3DA;
  PalWrite = $3C8;
  PalData  = $3C9;

ASM
     MOV  DX, CrtcPort
@VRetrace:
     IN   AL, DX
     TEST AL, 8
     JZ   @VRetrace    {Wait for end of vertical retrace}

     PUSH DS
     LDS  SI, APal
     MOV  CX, 256 * 3

     MOV  DX, PalWrite {Write}
     MOV  AL, 0
     OUT  DX, AL       {Set first color}
     MOV  DX, PalData  {Data}
     REP  OUTSB        {Set all colors}

     POP  DS
END;


PROCEDURE GetPal(VAR APal:TPal); ASSEMBLER;
CONST
  PalRead  = $3C7;
  PalData  = $3C9;
ASM
     LES  DI, APal
     MOV  CX, 256 * 3

     MOV  DX, PalRead  {Write}
     MOV  AL, 0
     OUT  DX, AL       {Set first color}
     MOV  DX, PalData  {Data}
     REP  INSB         {Set all colors}
END;





PROCEDURE InitPal(Brightnes:Byte);
VAR I,Col:Byte; Up:Boolean;

 PROCEDURE SetCol(Ndx,R,G,B:Byte);
 BEGIN
   Pal[Ndx].Red   := R;
   Pal[Ndx].Green := G;
   Pal[Ndx].Blue  := B;
 END;

 FUNCTION C:Byte;
 BEGIN
   C := Col+Brightnes;
 END;

BEGIN
  FillChar(Pal, SizeOf(Pal), 0);
  Col := 0;
  Up  := True;
  FOR I := 0 TO 32 DO
  BEGIN
    SetCol(I+32  ,0,0,C);         {Blue}
    SetCol(I+64  ,0,C,0);         {Green}
    SetCol(I+96  ,0,C,C);         {Cyan}
    SetCol(I+128 ,C,0,0);         {Red}
    SetCol(I+160 ,C,0,C);         {Purple}
    SetCol(I+192 ,C,C-5,0);       {Yellow}
    SetCol(I+223 ,C,C,C);         {Gray}
    IF Up THEN Inc(Col) ELSE Dec(Col);
    IF Col = 16 THEN Up := False;
  END;
END;

PROCEDURE CycleUp(FromCol,ToCol:Byte);
VAR Color1,Color2:TRgb; I,R:Byte;
BEGIN
  REPEAT
    Color1 := Pal[FromCol];
    FOR I := FromCol TO Pred(ToCol) DO
    BEGIN
      Color2 := Pal[I+1];
      Pal[I] := Color2
    END;
    Pal[ToCol] := Color1;
    SetPal(Pal);
  UNTIL KeyPressed;
END;

VAR I:Word;


BEGIN
  GetPal(Pal);
  FadeDownMax;
  SetVideoMode($13);

  InitPal(16);
  SetPal(Pal);

  FOR I := 3  TO 194 DO HLine(0,319 ,I-3,I+30);
  FOR I := 32 TO 159 DO HLine(29,289,I  ,I+1);
  FOR I := 64 TO 127 DO HLine(59,259,I  ,I+97);
  Pal[6].Red   := 38;
  Pal[6].Green := 48;
  Pal[6].Blue  := 41;

  PosCursor(13,12); BiosWrite(' MAZNO DEMO by ',6);
  PosCursor(13,13); BiosWrite(' The GodFather ',6);

  CycleUp(33,255);
  FadeDownMax;
  SetVideoMode($3);
  Writeln('MAZNO DEMO Version 1.0');
  Writeln('Copyright (C) 1996 by The GodFather');
END.
